<!DOCTYPE html>
<html lang="en">

<head>
    <title>Index page</title>
    <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css">
</head>

<body>
    <div class="container">
        <h2 align="center" class="text-danger">Iterators in JavaScript</h2>
        <hr />

        <!-- Javascript iterators tutorial -->
        <div id="title">
            <h4 class="text-info">What is a Iterator?</h4>
            <ul>
                <li>Introduced in ES6 to loop over any collection in javascript.</li>
                <li>According to ES6:
                    <ul>
                        <li>An <em>iterable</em> is a data structure that make its elements accessible to the public. It is implemented by a method whose key is <code>Symbol.iterator</code>.
                            <ul>
                                <li>The <code>Symbol.iterator</code> method returns an object (i.e. <mark>Iterator</mark>) with a method called <code>next()</code>, which assembles each value in the collection each time it gets called.</li>
                            </ul>
                        </li>
                        <li>An <em>iterator</em> is a pointer for traversing the elements of a data structure.</li>
                        <li><code>Array</code>, <code>String</code>, <code>Map</code>, <code>Set</code>, and <code>NodeList</code> are few objects that implement the iterable protocol.</li>
                    </ul>
                </li>
            </ul>
            <div>&nbsp;</div>

            <button id="btn_submit" type="button" class="btn btn-success" onclick="getEmployees();">Click me</button>
            <div>&nbsp;</div>

            <ul id="result"></ul>
        </div>
    </div>
    <script>
        var ul = document.getElementById("result");

        // User-defined array.
        let elist = [
				{ firstname: 'John', lastname: 'Lark' },
				{ firstname: 'Natalie', lastname: 'Atlas' },
				{ firstname: 'Daniel', lastname: 'Brown' },
				{ firstname: 'Tom', lastname: 'Hunt' },
				{ firstname: 'Edward', lastname: 'Clark' },
				{ firstname: 'Jason', lastname: 'Bourne' }
		];

        function getEmployees() {
            // Looping through the array elements to display the result.
            for (let employee of elist) {

                // Logic to create the dynamic 'li' tags.
                var li = document.createElement("li");
                li.appendChild(document.createTextNode(employee.firstname + " " + employee.lastname));
                ul.appendChild(li);
            }
        }
    </script>
</body>

</html>